/*
This is part of ScreenVWM, which is based in part on the Litestep
shell source code.

Copyright (C) 2008 Jim Babcock
Copyright (C) 1997-2008 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once

/////////////////////////////////////////////////////////////////////////////

class LayoutCacheNode
{
public:
	LayoutCacheNode(const LayoutCacheNode &copy);
	LayoutCacheNode(LayoutElement *element, ElementContext *context, SizeFallback *sizeFallback);
	~LayoutCacheNode();
	LayoutCacheNode *elementAtPoint(int x, int y);
	void traverse(vector<LayoutCacheNode*> &visited);
	
	/// Find the bottom-most element which has this node as a descendant and
	/// which has a variable [element-prefix][suffix] defined. Being defined as
	/// the empty string doesn't count. If there is no such element, returns
	/// NULL.
	LayoutCacheNode *findSuffix(string suffix);
	
	bool visited;
	
	LayoutElement *element;
	LayoutElement *origElement;
	ElementContext context;
	char *text;
	SizeFallback *sizeFallback;
	
	LayoutCacheNode *parent;
	vector<LayoutCacheNode*> children;
};
